package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.DilBatch;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface DilBatchMapper extends IBaseMapper<DilBatch, Short> {
    //获取当前序列值+1
    @Select("select seq_DIL_BATCH.nextval from dual")
    BigDecimal selectBatchId();

    //展示批次列表
    List<Map<String,Object>> getBatchList(Map<String,Object> map);

    //查询货权转移和提货委托出现的批次id
    List<Map<String,Object>> getBatchListFortTransfer(Map<String,Object> map);

    //模糊查询江船船名
    List<Map<String,Object>> getShipNameList(String state);

    //根据外轮船名和物资名称以及进厂船名查找新增批次是否存在
    BigDecimal selectBatchIdByName(Map<String,Object> map);

    //根据外轮船名和物资名称查找批次主表id是否存在
    BigDecimal selectBatchIdByForeign(Map<String,Object> map);

}