package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmsshipShipLocation;
import com.steerinfo.dil.model.TmsshipWaterQualityResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface TmsshipWaterQualityResultMapper extends IBaseMapper<TmsshipWaterQualityResult, BigDecimal> {
    // 查询最大id
    BigDecimal selectMaxId();

    // 插入
    int insert(TmsshipWaterQualityResult tmsshipWaterQualityResult);

    // 根据主键删除
    int deleteByPrimaryKey(BigDecimal resultId);


    //根据主键查看详细
    TmsshipWaterQualityResult selectByPrimaryKey(BigDecimal resultId);


    // 根据主键修改
    int updateByPrimaryKeySelective(TmsshipWaterQualityResult tmsshipWaterQualityResult);


    /**
     * 查询所有水分检测信息
     * @return
     */
    List<Map<String,Object>> selectWaterQualityList(Map<String,Object> mapVal);

    /**
     * 查询所有水分检测表单
     * @return
     */
    List<Map<String,Object>> selectWaterQuality(BigDecimal resultId);

    /**
     * 通过总实绩id获得实际装载重量
     * @param totalResultId
     * @return
     */
    BigDecimal selectRealWeight(BigDecimal totalResultId);

    /**
     * 根据子表id查询指令id
     * @param orderId
     */
    BigDecimal selectInstructionsId(BigDecimal orderId);

    @Select("select seq_TMSSHIP_QUALITY.nextval from dual")
    BigDecimal selectQualityId();

    // 得到放货日期
    Date getDeliveryDate(BigDecimal orderId);

    //获取实装吨位
    List<Map<String,Object>> getResultActualInstallations(BigDecimal batchId);

    //获得合同含水值
    String getPurchaseContractMoisture(BigDecimal batchId);
}