package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsshipCargoTransferResultMapper;
import com.steerinfo.dil.mapper.DilBatchMapper;
import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.model.DilBatch;
import com.steerinfo.dil.model.OmsshipShipmentInstructions;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.dil.model.AmsshipDeliveryNotice;
import com.steerinfo.dil.mapper.AmsshipDeliveryNoticeMapper;
import com.steerinfo.dil.service.IAmsshipDeliveryNoticeService;
import com.steerinfo.framework.utils.misc.IdGenerator;
import com.steerinfo.framework.utils.upload.UploadUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * AmsshipDeliveryNotice服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:54
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipDeliveryNotice服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipDeliveryNoticeService")
public class AmsshipDeliveryNoticeServiceImpl implements IAmsshipDeliveryNoticeService {

    @Autowired
    private AmsshipDeliveryNoticeMapper amsshipDeliveryNoticeMapper;
    @Autowired
    private AmsshipCargoTransferResultMapper cargoTransferResultMapper;
    @Autowired
    private DilBatchServiceImpl dilBatchService;
    @Autowired
    private DilBatchMapper dilBatchMapper;



    //查询所有数据
    @Override
    public List<Map<String, Object>> selectShipDeliveryNotice(Map<String, Object> mapVal) {
        return amsshipDeliveryNoticeMapper.selectShipDeliveryNotice(mapVal);
    }
    //新增发货通知
    @Override
    @Transactional
    public int insert(Map<String,Object> map) {
        int i=0;
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        String userId =(String) map.get("userId");
        String userName=null;
        if (userId!=null){
             userName = cargoTransferResultMapper.getUserNameByUserId(userId);
        }
        BigDecimal noticeId = amsshipDeliveryNoticeMapper.selectNoticeId();
        amsshipDeliveryNotice.setNoticeId(noticeId);
        //新增承运商
        if (map.get("carrierId")!=null) {
            amsshipDeliveryNotice.setCarrierId(DataChange.dataToBigDecimal(map.get("carrierId")));
        }
        if (map.get("requesterGroupId")!=null) {
            amsshipDeliveryNotice.setRequesterGroupId(DataChange.dataToBigDecimal(map.get("requesterGroupId")));
        }
        amsshipDeliveryNotice.setNoticeCommerceMethod((String) map.get("noticeCommerceMethod"));
        amsshipDeliveryNotice.setNoticeHandoverMethod((String) map.get("noticeHandoverMethod"));
        if (map.get("portId")!=null) {
            amsshipDeliveryNotice.setPortId(DataChange.dataToBigDecimal(map.get("portId")));
        }

        if (map.get("noticePortConstructionFee")!=null) {
            amsshipDeliveryNotice.setNoticePortConstructionFee(DataChange.dataToBigDecimal(map.get("noticePortConstructionFee")));
        }
        long noticeDeliveryTime =(long) map.get("noticeDeliveryTime");
        amsshipDeliveryNotice.setNoticeDeliveryTime(new Date(noticeDeliveryTime));
        amsshipDeliveryNotice.setNoticePileFreeDays(DataChange.dataToBigDecimal(map.get("noticePileFreeDays")));
        amsshipDeliveryNotice.setNoticeDistributionStatus(new BigDecimal(0));
        if (map.get("purchaseContractUnitPrice")!=null) {
            amsshipDeliveryNotice.setPurchaseContractUnitPrice(DataChange.dataToBigDecimal(map.get("purchaseContractUnitPrice")));
        }
        if (map.get("purchaseContractMoisture")!=null) {
            amsshipDeliveryNotice.setPurchaseContractMoisture((String) map.get("purchaseContractMoisture"));
        }
        if (map.get("purchaseContractQualityindex")!=null) {
            amsshipDeliveryNotice.setPurchaseContractUnitPrice(DataChange.dataToBigDecimal(map.get("purchaseContractQualityindex")));
        }
        if (map.get("tfeContent")!=null) {
            amsshipDeliveryNotice.setTfeContent((String) map.get("tfeContent"));
        }
        if (map.get("silicaContent")!=null){
            amsshipDeliveryNotice.setSilicaContent((String)map.get("silicaContent"));
        }
        if (map.get("aluminaContent")!=null){
            amsshipDeliveryNotice.setAluminaContent((String)map.get("aluminaContent"));
        }
        if (map.get("phosphorusContent")!=null){
            amsshipDeliveryNotice.setPhosphorusContent((String)map.get("phosphorusContent"));
        }
        if (map.get("manganeseContent")!=null){
            amsshipDeliveryNotice.setManganeseContent((String)map.get("manganeseContent"));
        }
        amsshipDeliveryNotice.setInsertTime(new Date());
        amsshipDeliveryNotice.setInsertUsername(userId);
        amsshipDeliveryNotice.setDeleted(new BigDecimal(0));
        //联系人
        amsshipDeliveryNotice.setResultContactPerson((String) map.get("resultContactPerson"));
        amsshipDeliveryNotice.setResultTelephoneFax((String) map.get("resultTelephoneFax"));
        //货代信息
        amsshipDeliveryNotice.setResultFreightForwardingInfo((String) map.get("resultFreightForwardingInfo"));
        //备注
        amsshipDeliveryNotice.setResultMemo((String) map.get("resultMemo"));
        //放货数量
        amsshipDeliveryNotice.setResultNumberOfLoans(DataChange.dataToBigDecimal(map.get("resultNumberOfLoans")));
        //货权转移送达单位
        amsshipDeliveryNotice.setCargoId(DataChange.dataToBigDecimal(map.get("cargoId")));
        //收货人单位
        amsshipDeliveryNotice.setGroupId(DataChange.dataToBigDecimal(map.get("groupId")));
        amsshipDeliveryNotice.setMaterialTypeId(DataChange.dataToBigDecimal(map.get("materialTypeId")));
        amsshipDeliveryNotice.setIsNeedPortFee((String) map.get("isNeedPortFee"));
        amsshipDeliveryNotice.setIsNeedPortCharge((String) map.get("isNeedPortDisCharge"));
        amsshipDeliveryNotice.setCargoImageUrl((String) map.get("cargoPictureUrl"));
        //生成批次
        //根据物资和外轮船名判断批次是否存在
        BigDecimal batchFacotryId = dilBatchMapper.selectBatchIdByName(map);
        //如果存在则取批次id
        if (batchFacotryId != null && batchFacotryId.intValue() != 0){
            amsshipDeliveryNotice.setBatchId(batchFacotryId);
        }else {
            Map<String, Object> map1 = dilBatchService.insertBatchId(map);
            if (map1 != null) {
                System.out.println("新增批次成功");
                BigDecimal batchIdInfacotryId = DataChange.dataToBigDecimal(map1.get("batchIdInfacotryId"));
                amsshipDeliveryNotice.setBatchId(batchIdInfacotryId);
            } else {
                System.out.println("新增批次失败");
            }
        }
        i += amsshipDeliveryNoticeMapper.insertSelective(amsshipDeliveryNotice);
        return i ;
    }

    @Override
    public int sendDeliveryNotice(Map<String, Object> map) {
        BigDecimal noticeId =DataChange.dataToBigDecimal(map.get("noticeId"));
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        amsshipDeliveryNotice.setNoticeId(noticeId);
        amsshipDeliveryNotice.setNoticeDistributionStatus(new BigDecimal(1));
        return amsshipDeliveryNoticeMapper.updateByPrimaryKeySelective(amsshipDeliveryNotice);
    }

    @Override
    public int deleteByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.deleteByPrimaryKey(noticeId);
    }

    @Override
    public int updateByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.updateByPrimaryKey(noticeId);
    }


    @Override
    public AmsshipDeliveryNotice selectByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.selectByPrimaryKey(noticeId);
    }

    @Override
    public List<Map<String, Object>> getResultNumber() {
        return amsshipDeliveryNoticeMapper.getResultNumber();
    }
    //货权转移下拉框
    @Override
    public List<Map<String, Object>> getcarrier() {
        return amsshipDeliveryNoticeMapper.getcarrier();
    }
////采购订单号下拉框
//    @Override
//    public List<Map<String, Object>> getOrderNo() {
//        return amsshipDeliveryNoticeMapper.getOrderNo();
//    }

    @Override
    public List<Map<String, Object>> getShipper() {
        return amsshipDeliveryNoticeMapper.getShipper();
    }

    @Override
    public int deleteDeliveryNotice(Map<String, Object> map) {
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        amsshipDeliveryNotice.setNoticeId(DataChange.dataToBigDecimal(map.get("noticeId")));
        amsshipDeliveryNotice.setDeleted(new BigDecimal(1));
        return amsshipDeliveryNoticeMapper.updateByPrimaryKeySelective(amsshipDeliveryNotice);
    }


    @Override
    public List<Map<String, Object>> selectByNoticeId(Integer noticeId) {
        return amsshipDeliveryNoticeMapper.selectByNoticeId(noticeId);
    }


    //更新发货通知
    @Override
    public int updateAmsDeliveryNotice(Map<String, Object> map) {
        int i=0;
        BigDecimal noticeId = DataChange.dataToBigDecimal(map.get("noticeId"));
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        if (map.get("noticeId")!=null) {
            amsshipDeliveryNotice.setNoticeId(noticeId);
        }
        BigDecimal carrierId =DataChange.dataToBigDecimal(map.get("carrierId"));
        if (map.get("carrierId")!=null) {
            amsshipDeliveryNotice.setCarrierId(carrierId);
        }
        BigDecimal requesterGroupId =DataChange.dataToBigDecimal(map.get("requesterGroupId"));
        if (map.get("requesterGroupId")!=null) {
            amsshipDeliveryNotice.setRequesterGroupId(requesterGroupId);
        }
        //贸易方式
        if (map.get("noticeCommerceMethod")!=null) {
            amsshipDeliveryNotice.setNoticeHandoverMethod((String) map.get("noticeCommerceMethod"));
        }
        //交接方式
        if (map.get("noticeHandoverMethod")!=null) {
            amsshipDeliveryNotice.setNoticeCommerceMethod((String) map.get("noticeHandoverMethod"));
        }
        //港口id
        if (map.get("portId")!=null) {
            amsshipDeliveryNotice.setPortId(DataChange.dataToBigDecimal(map.get("portId")));
        }
        //港建费金额
        if (map.get("noticePortConstructionFee")!=null) {
            amsshipDeliveryNotice.setNoticePortConstructionFee(DataChange.dataToBigDecimal(map.get("noticePortConstructionFee")));
        }
        //放货时间
        if (map.get("noticeDeliveryTime")!=null) {
            long noticeDeliveryTime = (long) map.get("noticeDeliveryTime");
            amsshipDeliveryNotice.setNoticeDeliveryTime(new Date(noticeDeliveryTime));
        }
        //免堆天数
        if (map.get("noticePileFreeDays")!=null){
            amsshipDeliveryNotice.setNoticePileFreeDays(DataChange.dataToBigDecimal(map.get("noticePileFreeDays")));
        }
        //单价
        if (map.get("purchaseContractUnitPrice")!=null){
            amsshipDeliveryNotice.setPurchaseContractUnitPrice(DataChange.dataToBigDecimal(map.get("purchaseContractUnitPrice")));
        }
        //合同水分
        if (map.get("purchaseContractMoisture")!=null){
            amsshipDeliveryNotice.setPurchaseContractMoisture((String) map.get("purchaseContractMoisture"));
        }
        //微元素含量
        if (map.get("tfeContent")!=null){
            amsshipDeliveryNotice.setTfeContent((String) map.get("tfeContent"));
        }
        if (map.get("silicaContent")!=null){
            amsshipDeliveryNotice.setSilicaContent((String) map.get("silicaContent"));
        }
        if (map.get("aluminaContent")!=null){
            amsshipDeliveryNotice.setAluminaContent((String) map.get("aluminaContent"));
        }
        if (map.get("phosphorusContent")!=null){
            amsshipDeliveryNotice.setPhosphorusContent((String) map.get("phosphorusContent"));
        }
        if (map.get("manganeseContent")!=null){
            amsshipDeliveryNotice.setManganeseContent((String) map.get("manganeseContent"));
        }
        //联系人
        if (map.get("resultContactPerson")!=null){
            amsshipDeliveryNotice.setResultContactPerson((String) map.get("resultContactPerson"));
        }
        if (map.get("resultTelephoneFax")!=null){
            amsshipDeliveryNotice.setResultTelephoneFax((String) map.get("resultTelephoneFax"));
        }
        if (map.get("resultFreightForwardingInfo")!=null){
            amsshipDeliveryNotice.setResultFreightForwardingInfo((String) map.get("resultFreightForwardingInfo"));
        }
        if (map.get("resultMemo")!=null){
            amsshipDeliveryNotice.setResultMemo((String) map.get("resultMemo"));
        }
        if (map.get("resultNumberOfLoans")!=null){
            amsshipDeliveryNotice.setResultNumberOfLoans(DataChange.dataToBigDecimal(map.get("resultNumberOfLoans")));
        }
        if (map.get("cargoId")!=null){
            amsshipDeliveryNotice.setCargoId(DataChange.dataToBigDecimal(map.get("cargoId")));
        }
        if (map.get("groupId")!=null){
            amsshipDeliveryNotice.setGroupId(DataChange.dataToBigDecimal(map.get("groupId")));
        }
        if (map.get("inFactoryShipName")!=null||map.get("materialId")!=null||map.get("foreignShipName")!=null){
           //判断如果外轮船名或物资id或进厂船名不为空
            //根据物资和外轮船名判断批次是否存在
            BigDecimal batchFacotryId = dilBatchMapper.selectBatchIdByName(map);
            //如果存在则取批次id
            if (batchFacotryId != null && batchFacotryId.intValue() != 0){
                amsshipDeliveryNotice.setBatchId(batchFacotryId);
            }else {
                Map<String, Object> map1 = dilBatchService.insertBatchId(map);
                if (map1 != null) {
                    System.out.println("新增批次成功");
                    BigDecimal batchIdInfacotryId = DataChange.dataToBigDecimal(map1.get("batchIdInfacotryId"));
                    amsshipDeliveryNotice.setBatchId(batchIdInfacotryId);
                } else {
                    System.out.println("新增批次失败");
                }
            }
        }
        if (map.get("materialTypeId")!=null){
            amsshipDeliveryNotice.setMaterialTypeId(DataChange.dataToBigDecimal(map.get("materialTypeId")));
        }
        if (map.get("isNeedPortDisCharge")!=null){
            amsshipDeliveryNotice.setIsNeedPortCharge((String) map.get("isNeedPortDisCharge"));
        }
        if (map.get("isNeedPortFee")!=null){
            amsshipDeliveryNotice.setIsNeedPortFee((String) map.get("isNeedPortFee"));
        }
        if (map.get("cargoPictureUrl")!=null){
            amsshipDeliveryNotice.setCargoImageUrl((String) map.get("cargoPictureUrl"));
        }
        if (map.get("userId")!=null){
            amsshipDeliveryNotice.setUpdateUsername((String) map.get("userId"));
        }
        amsshipDeliveryNotice.setUpdateTime(new Date());
        i += amsshipDeliveryNoticeMapper.updateByPrimaryKeySelective(amsshipDeliveryNotice);
        return i;
    }

    @Override
    public String getLoadDeliveryNotice(Integer noticeId) {
        return amsshipDeliveryNoticeMapper.getLoadDeliveryNotice(noticeId);
    }


}
