package com.steerinfo.dil.service.impl;


import com.steerinfo.dil.mapper.DilBatchInfacotryMapper;
import com.steerinfo.dil.mapper.DilBatchMapper;
import com.steerinfo.dil.model.DilBatch;
import com.steerinfo.dil.model.DilBatchInfacotry;
import com.steerinfo.dil.service.IDilBatchService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * DilBatch服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-06 10:22
 * 类描述
 * 修订历史：
 * 日期：2021-11-06
 * 作者：generator
 * 参考：
 * 描述：DilBatch服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "dilBatchService")
public class DilBatchServiceImpl  implements IDilBatchService {

    @Autowired
    private DilBatchMapper dilBatchMapper;
    @Autowired
    private DilBatchInfacotryMapper dilBatchInfacotryMapper;



    @Override
    public List<Map<String, Object>> getBatchList(Map<String, Object> map) {
        return dilBatchMapper.getBatchList(map);
    }

    @Override
    public List<Map<String, Object>> getBatchListFortTransfer(Map<String, Object> map) {
        return dilBatchMapper.getBatchListFortTransfer(map);
    }

    @Override
    public List<Map<String, Object>> getShipNameList(String state) {
        state = "%"+state+"%";
        return dilBatchMapper.getShipNameList(state);
    }

    //新增批次
    @Transactional
    @Override
    public Map<String,Object> insertBatchId(Map<String, Object> map) {
        String inFactoryShipName = (String) map.get("inFactoryShipName");
        String foreignShipName = (String) map.get("foreignShipName");
        BigDecimal materialId = DataChange.dataToBigDecimal(map.get("materialId"));
        String userId = (String) map.get("userId");
        DilBatchInfacotry dilBatchInfacotry=new DilBatchInfacotry();
        //首先根据外轮船名和批次查找批次主表id是否存在
        BigDecimal BatchId = dilBatchMapper.selectBatchIdByForeign(map);
        if (BatchId!=null){
            dilBatchInfacotry.setBatchId(BatchId);
        }else {
            DilBatch dilBatch = new DilBatch();
            BigDecimal batchId1 = dilBatchMapper.selectBatchId();
            dilBatch.setBatchId(batchId1);
            dilBatch.setResultForeignShipName(foreignShipName);
            dilBatch.setMaterialId(materialId);
            //新增次表
            dilBatchInfacotry.setBatchId(batchId1);
            dilBatch.setInsertTime(new Date());
            dilBatch.setInsertUsername(userId);
            int i = dilBatchMapper.insertSelective(dilBatch);
            if (i==0){
                System.out.println("新增主表失败!!!");
            }
        }
        BigDecimal batchIdInfacotryId = dilBatchInfacotryMapper.selectDilBatchId();
        dilBatchInfacotry.setBatchInfacotryId(batchIdInfacotryId);
        dilBatchInfacotry.setInfactoryShipName(inFactoryShipName);
        dilBatchInfacotry.setInsertUsername(userId);
        dilBatchInfacotry.setInsertTime(new Date());
        map.put("batchIdInfacotryId",batchIdInfacotryId);
        int j= dilBatchInfacotryMapper.insertSelective(dilBatchInfacotry);
        if (j==0){
            System.out.println("新增批次中间表失败!!!");
        }
        return map;
    }
}
