package com.steerinfo.dil.service.impl;
import com.steerinfo.dil.model.AmsshipDeliveryNotice;
import com.steerinfo.dil.model.DilBatch;
import com.steerinfo.dil.model.TmsshipLoadShipResult;
import com.steerinfo.dil.model.TmsshipWaterQualityResult;
import com.steerinfo.dil.mapper.TmsshipWaterQualityResultMapper;
import com.steerinfo.dil.service.ITmsshipWaterQualityResultService;
import com.steerinfo.dil.util.DataChange;
import io.swagger.models.auth.In;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmsshipWaterQualityResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:01
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmsshipWaterQualityResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmsshipWaterQualityResultService")
public class TmsshipWaterQualityResultServiceImpl implements ITmsshipWaterQualityResultService {

    @Autowired
    TmsshipWaterQualityResultMapper tmsshipWaterQualityResultMapper;
    @Autowired
    TmsshipLoadShipResultServiceImpl tmsshipLoadShipResultService;
    @Autowired
    TmsshipTotalResultServiceImpl tmsshipTotalResultService;


    /**
     * 查询最大id
     * @return
     */
    @Override
    public BigDecimal selectMaxId() {
        return tmsshipWaterQualityResultMapper.selectQualityId();
    }

    /**
     * 新增水分检测
     * @param map
     * @return
     */
    @Override
    public int insertWaterQualityResult(Map<String,Object> map) {
        Map<String,Object> mapVal = (Map<String, Object>) map.get("mapVal");
        Map<String,Object> waterQualityMap = (Map<String, Object>) map.get("waterQualityMap");
        TmsshipWaterQualityResult tmsshipWaterQualityResult = new TmsshipWaterQualityResult();
        BigDecimal resultId = selectMaxId();
        BigDecimal orderId = new BigDecimal((Integer) waterQualityMap.get("orderId"));
        BigDecimal totalResultId = tmsshipTotalResultService.getResultTotalId(orderId);
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        TmsshipLoadShipResult tmsshipLoadShipResult=new TmsshipLoadShipResult();
        //空舱/重载水尺米
       String resultEmptyHeavyWaterMeter= (String) mapVal.get("resultEmptyHeavyWaterMeter");
        if(resultEmptyHeavyWaterMeter.equals("电子磅交接")){
            tmsshipWaterQualityResult.setResultEmptyHeavyWaterMeter(new BigDecimal(0));
        }else if(resultEmptyHeavyWaterMeter.equals("地磅交接")){
            tmsshipWaterQualityResult.setResultEmptyHeavyWaterMeter(new BigDecimal(1));
        }

      //  Date resultEsDeliveryDate = tmsshipWaterQualityResultMapper.getDeliveryDate(orderId);

        //检测费
         String resultInspectionFees= (String) mapVal.get("resultInspectionFees");
         if(resultInspectionFees.equals("2000元/船")){
             tmsshipWaterQualityResult.setResultInspectionFees(new BigDecimal(2000));
         }else if(resultInspectionFees.equals("3000元/船")){
             tmsshipWaterQualityResult.setResultInspectionFees(new BigDecimal(3000));
         }
       //计划日期
        Date resultPlannedDate = new Date((Long) mapVal.get("resultPlannedDate"));
         tmsshipWaterQualityResult.setResultPlannedDate(resultPlannedDate);
         //预计放货日期
        Date expectNoticeDate=new Date((Long)mapVal.get("expectNoticeDate"));
        tmsshipWaterQualityResult.setResultEsDeliveryDate(expectNoticeDate);
        //含水率
        BigDecimal resultMoistureContent = new BigDecimal((String)mapVal.get("resultMoistureContent"));
        tmsshipWaterQualityResult.setResultMoistureContent(resultMoistureContent);
        //合同水分值
        String purchaseContractMoisture=(String)mapVal.get("contractMoistureValue");
        amsshipDeliveryNotice.setPurchaseContractMoisture(purchaseContractMoisture);
        //实装吨位
        BigDecimal resultActualInstallations = DataChange.dataToBigDecimal(mapVal.get("realWeight"));
        tmsshipLoadShipResult.setResultActualInstallations( resultActualInstallations);
        //水分吨位
        BigDecimal moistureTonnage = new BigDecimal((String) mapVal.get("moistureTonnage"));
        tmsshipWaterQualityResult.setResultWaterTonnage(moistureTonnage);
        //装船比例
        BigDecimal instructionsId = selectInstructionsId(orderId);
        BigDecimal weights = tmsshipLoadShipResultService.selectAllWeight(instructionsId);
        Double ratio = resultActualInstallations.doubleValue()/weights.doubleValue();
        String strRatio = ratio.toString();
        String shipmentRatio;
        if (strRatio.length() < 7) {
            shipmentRatio = strRatio;
        }
        else {
            shipmentRatio = strRatio.substring(0, 6);
        }
        BigDecimal resultShipmentRatio = new BigDecimal(shipmentRatio);
        tmsshipWaterQualityResult.setResultShipmentRatio(resultShipmentRatio);
        // 设置对象属性值
        tmsshipWaterQualityResult.setResultId(resultId);
        tmsshipWaterQualityResult.setTotalResultId(totalResultId);

        // 设置常规字段
        tmsshipWaterQualityResult.setInsertTime(new Date());
        tmsshipWaterQualityResult.setInsertUsername("admin");
        tmsshipWaterQualityResult.setInsertUpdateRemark("无");
        tmsshipWaterQualityResult.setUpdateTime(new Date());
        tmsshipWaterQualityResult.setUpdateUsername("admin");
        tmsshipWaterQualityResult.setDeleteName(null);
        tmsshipWaterQualityResult.setDeleteTime(null);
        tmsshipWaterQualityResult.setDeleted(new BigDecimal(0));
        return tmsshipWaterQualityResultMapper.insert(tmsshipWaterQualityResult);
    }

    /**
     * 通过主键删除水分质检
     * @param resultId
     * @return
     */
    @Override
    public int deleteWaterQualityResult(BigDecimal resultId) {
        TmsshipWaterQualityResult tmsshipWaterQualityResult = selectWaterQualityResult(resultId);
        tmsshipWaterQualityResult.setDeleted(new BigDecimal(1));
        return tmsshipWaterQualityResultMapper.updateByPrimaryKeySelective(tmsshipWaterQualityResult);
    }

    /**
     * 通过主键查询水分质检
     * @param resultId
     * @return
     */
    @Override
    public TmsshipWaterQualityResult selectWaterQualityResult(BigDecimal resultId) {
        return tmsshipWaterQualityResultMapper.selectByPrimaryKey(resultId);
    }

    /**
     * 修改水分质检信息
     * @param tmsshipWaterQualityResult
     * @return
     */
    @Override
    public int updateWaterQualityResult(TmsshipWaterQualityResult tmsshipWaterQualityResult) {
        tmsshipWaterQualityResult.setUpdateTime(new Date());
        return tmsshipWaterQualityResultMapper.updateByPrimaryKeySelective(tmsshipWaterQualityResult);
    }

    /**
     * 查询所有水分质检信息
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> selectWaterQualityList(Map<String, Object> mapVal) {
        List<Map<String, Object>> mapList = tmsshipWaterQualityResultMapper.selectWaterQualityList(mapVal);
        String result;
        DecimalFormat df = new DecimalFormat("0.0000");
        for (Map<String, Object> map : mapList) {
            if(((BigDecimal)map.get("resultEmptyHeavyWaterMeter")).intValue() == 0){
                result="电子磅交接";
            }
            else {
                result="地磅交接";
            }
            map.put("resultEmptyHeavyWaterMeter",result);
            Object waterWeight = map.get("waterWeight");
            if(waterWeight != null){
                BigDecimal data = DataChange.dataToBigDecimal(waterWeight);
                String weightFormat = df.format(data);
                map.put("waterWeight", weightFormat);
            }
        }
        return mapList;
    }

    /**
     * 查询所有水分质检表单
     * @param resultId
     * @return
     */
    @Override
    public List<Map<String, Object>> getWaterQuality(BigDecimal resultId) {
        return tmsshipWaterQualityResultMapper.selectWaterQuality(resultId);
    }

    /**
     * 通过总实绩id查询装船的实际重量
     * @param totalResultId
     * @return
     */
    @Override
    public BigDecimal selectRealWeight(BigDecimal totalResultId) {
        return tmsshipWaterQualityResultMapper.selectRealWeight(totalResultId);
    }



    /**
     * 通过子表id查询指令id
     * @param orderId
     * @return
     */
    @Override
    public BigDecimal selectInstructionsId(BigDecimal orderId) {
        return tmsshipWaterQualityResultMapper.selectInstructionsId(orderId);
    }

    //根据选中的批次id获取合同水分值、实装吨位
    @Override
     public Map<String,Object> getMoistureAndInstallations(Map<String,Object> map) {
        DilBatch dilBatch=new DilBatch();
        TmsshipWaterQualityResult tmsshipWaterQualityResult=new TmsshipWaterQualityResult();
        TmsshipLoadShipResult tmsshipLoadShipResult=new TmsshipLoadShipResult();
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        //获得批次号id
        BigDecimal batchId = new BigDecimal((Integer) map.get("batchId"));
        dilBatch.setBatchId(batchId);
        //获得含水率
        BigDecimal resultMoistureContent = new BigDecimal(map.get("resultMoistureContent").toString());
        tmsshipWaterQualityResult.setResultMoistureContent(resultMoistureContent);
       //获得实装吨位
        List<Map<String,Object>> resultActualInstallations = getResultActualInstallations(batchId);
        Map<String, Object> stringObjectMap = resultActualInstallations.get(0);
        BigDecimal resultActualInstallations1 =DataChange.dataToBigDecimal(stringObjectMap.get("resultActualInstallations"));
        tmsshipLoadShipResult.setResultActualInstallations(resultActualInstallations1);
        //获得合同含水率
        String purchaseContractMoisture=getPurchaseContractMoisture(batchId);
        amsshipDeliveryNotice.setPurchaseContractMoisture(purchaseContractMoisture);
        //根据获得的含水率和实装吨位，计算水分吨位
        DecimalFormat df=new DecimalFormat("#.0000");
        String resultWaterTonnage=df.format(resultActualInstallations1.doubleValue() * resultMoistureContent.doubleValue());
        tmsshipWaterQualityResult.setResultWaterTonnage(new BigDecimal(resultWaterTonnage));
        Map<String,Object> map1=new HashMap<>();
        map1.put("purchaseContractMoisture",purchaseContractMoisture);
        map1.put("resultActualInstallations",resultActualInstallations1);
        map1.put("resultWaterTonnage",resultWaterTonnage );
        return map1;
    }

    //获得实装吨位
    public List<Map<String, Object>> getResultActualInstallations(BigDecimal batchId){
        return tmsshipWaterQualityResultMapper.getResultActualInstallations(batchId);
    }

    //获得合同含水值
    public String getPurchaseContractMoisture(BigDecimal batchId){
        return tmsshipWaterQualityResultMapper.getPurchaseContractMoisture(batchId);
    }
}
